//
//  HYDServerAPI.m
//  IOS_百思不得姐
//
//  Created by mac on 17/1/11.
//  Copyright © 2017年 mac. All rights reserved.
//

#import "HYDServerAPI.h"
#import "SVProgressHUD.h"

@interface HYDServerAPI()


@end

@implementation HYDServerAPI

//获取订阅左侧标签
#define SubscribeLeft @"http://api.budejie.com/api/api_open.php?a=category&c=subscribe"
//获取“推荐关注”中左侧标签每个标签对应的推荐用户组
#define RecommentUser @"http://api.budejie.com/api/api_open.php?a=list&c=subscribe"
//获取热贴推荐
#define HotRecommend @"http://api.budejie.com/api/api_open.php?a=tag_recommend&c=topic"



+(void)getRequest:(NSString *)url paramenter:(NSDictionary *)paramenter success:(void(^)(id response))success failuer:(void(^)(id error))failuer{
    [SVProgressHUD showWithMaskType:SVProgressHUDMaskTypeBlack];//SVProgressHUD的遮罩模式
    
    AFHTTPRequestOperationManager *manager = [AFHTTPRequestOperationManager manager];
    [manager setResponseSerializer:[AFXMLParserResponseSerializer new]];
    manager.requestSerializer.timeoutInterval = 10.0f;//访问超时设置
    manager.responseSerializer = [AFJSONResponseSerializer serializer];//返回类型位
    [manager GET:url parameters:paramenter success:^(AFHTTPRequestOperation *operation, id responseObject) {
        success(responseObject);
        [SVProgressHUD dismiss];
    } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
        failuer(error);
        [SVProgressHUD showErrorWithStatus:@"网络超时" duration:0.5f];
    }];
}


//获取订阅左侧标签
+(void)getSubscribeLeftLabel:(void(^)(id response))success failuer:(void(^)(id error))failuer{
    
    [self getRequest:SubscribeLeft paramenter:nil success:^(id response) {
        success(response);
    } failuer:^(id error) {
        failuer(error);
    }];
    
}

//获取“推荐关注”中左侧标签每个标签对应的推荐用户组
+(void)getRecommentUserData:(NSString *)userid success:(void(^)(id response))success failuer:(void(^)(id error))failuer{
    
    NSString *str = [NSString stringWithFormat:@"%@&category_id=%@",RecommentUser,userid];

    [self getRequest:str paramenter:nil success:^(id response) {
        success(response);
        [SVProgressHUD dismiss];
    } failuer:^(id error) {
        [SVProgressHUD dismiss];

        failuer(error);
    }];
}

//推荐关注标签的加载数据
+(void)uploadRecommentUserData:(NSString *)userid page:(NSString *)page success:(void(^)(id response))success failuer:(void(^)(id error))failuer{
    
    NSString *str = [NSString stringWithFormat:@"%@&category_id=%@&page=%@",RecommentUser,userid,page];
    AFHTTPRequestOperationManager *manager = [AFHTTPRequestOperationManager manager];
    [manager setResponseSerializer:[AFXMLParserResponseSerializer new]];
    manager.requestSerializer.timeoutInterval = 10.0f;
    manager.responseSerializer = [AFJSONResponseSerializer serializer];//返回类型位
    [manager GET:str parameters:nil success:^(AFHTTPRequestOperation *operation, id responseObject) {
        success(responseObject);
    } failure:^(AFHTTPRequestOperation *operation, NSError *error) {
        failuer(error);
        [SVProgressHUD showErrorWithStatus:@"获取数据失败" duration:0.5f];
    }];    
}

//热帖推荐
+(void)HotRecommendData:(void(^)(id response))success failuer:(void(^)(id error))failuer{
    
    [self getRequest:HotRecommend paramenter:nil success:^(id response) {
        success(response);
    } failuer:^(id error) {
        failuer(error);
    }];
    
}

@end
