//
//  HYDSubscribeViewController.m
//  IOS_百思不得姐
//
//  Created by mac on 17/1/11.
//  Copyright © 2017年 mac. All rights reserved.
//

#import "HYDSubscribeViewController.h"
#import "HYDSubscribeModel.h"
#import "HYDFristTableViewCell.h"
#import "HYDSecondTableViewCell.h"
#import "MJExtension.h"
#import "HYDRecommendUser.h"
#import "MJRefresh.h"
#import "HYDUserModel.h"


@interface HYDSubscribeViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic,strong) NSMutableArray *leftLabelAry;//左边的tabelview
@property (nonatomic,strong) NSMutableArray *rightLabelAry;
@property (nonatomic,strong) NSMutableDictionary *typeDic;

@property (nonatomic,strong) UITableView *fristTableView;
@property (nonatomic,strong) UITableView *secondTableView;

@property (nonatomic,assign) NSInteger *page;//页数
@property (nonatomic,copy) NSString *distinguishStr;//判别str
@end

@implementation HYDSubscribeViewController

+(void)initialize{
    UITableViewCell *cell = [UITableViewCell appearance];
    [cell setBackgroundColor:[UIColor clearColor]];
}

- (void)viewDidLoad {

    [super viewDidLoad];
    [self.view setBackgroundColor:[UIColor whiteColor]];
    self.typeDic = [[NSMutableDictionary alloc]init];
    self.title = @"瀑布流";
    
    [HYDServerAPI getSubscribeLeftLabel:^(id response) {
        self.leftLabelAry = response[@"list"];
        
        HYDLog(@"%@",self.leftLabelAry);
        
        [self.fristTableView reloadData];
       //table select第一个cell
        [self.fristTableView selectRowAtIndexPath:[NSIndexPath indexPathForRow:0 inSection:0] animated:nil scrollPosition:UITableViewScrollPositionTop];
        
        [self updataFrist:[self.leftLabelAry[0] objectForKey:@"id"]];
        
    } failuer:^(id error) {
        
    }];
    
    //设置TableView
    [self creatFristTableView];
}

//进来的时候加载第一个推荐
-(void)updataFrist:(NSString *)userid{

    [HYDServerAPI getRecommentUserData:userid success:^(id response) {
        NSArray *ary = [HYDRecommendUser objectArrayWithKeyValuesArray:response[@"list"]];
        HYDUserModel *user = [[HYDUserModel alloc]init];
        NSMutableArray *mutableAry = [NSMutableArray array];
        [mutableAry addObjectsFromArray:ary];
        user.userAry = mutableAry;
        user.page = response[@"next_page"];
        user.maxPage = response[@"total_page"];
        [self.typeDic setValue:user forKey:userid];
     
        self.rightLabelAry = user.userAry;
        
        [self.secondTableView reloadData];
        self.secondTableView.mj_footer.hidden = NO;
    } failuer:^(id error) {
        
    }];
    
}


-(void)creatFristTableView{
    
    self.automaticallyAdjustsScrollViewInsets = NO;

    self.fristTableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 64, 64,ScreenHeight-64)];
    self.fristTableView.delegate = self;
    self.fristTableView.dataSource = self;
    [self.fristTableView BackgroupColour];
    [self.fristTableView setSeparatorColor:[UIColor whiteColor]];//分割线的颜色
    self.fristTableView.tableFooterView = [UIView new];//隐藏多余的分割线
    [self.view addSubview:self.fristTableView];
    
    self.secondTableView = [[UITableView alloc]initWithFrame:CGRectMake(self.fristTableView.width, 64, ScreenWidth-64,ScreenHeight-64)];
    self.secondTableView.delegate = self;
    self.secondTableView.dataSource = self;
    [self.secondTableView setBackgroundColor:HYDColour(250, 233, 233)];
    [self.secondTableView setSeparatorColor:[UIColor whiteColor]];
    self.secondTableView.tableFooterView = [UIView new];
    
    //添加下拉刷新控件
    self.secondTableView.mj_header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
//        self.secondTableView.mj_footer.hidden = NO;
        NSDictionary *dic = self.leftLabelAry[self.fristTableView.indexPathForSelectedRow.row];
        NSString *cellid = dic[@"id"];
        self.distinguishStr = cellid;
        [HYDServerAPI getRecommentUserData:cellid success:^(id response) {
            NSArray *ary = [HYDRecommendUser objectArrayWithKeyValuesArray:response[@"list"]];
            HYDUserModel *user = [[HYDUserModel alloc]init];
            NSMutableArray *mutableAry = [NSMutableArray array];
            [mutableAry addObjectsFromArray:ary];
            user.userAry = mutableAry;
            user.page = response[@"next_page"];
            user.maxPage = response[@"total_page"];
            [self.typeDic setValue:user forKey:cellid];
            
            self.rightLabelAry = user.userAry;
            
            [self.secondTableView reloadData];

            [self.secondTableView.mj_header endRefreshing];
            [self.secondTableView.mj_footer endRefreshing];
        } failuer:^(id error) {
            [self.secondTableView.mj_header endRefreshing];
            [self.secondTableView.mj_footer endRefreshing];
        }];
        [self.secondTableView.mj_header endRefreshing];
    }];
    
    //添加上拉加载
    self.secondTableView.mj_footer = [MJRefreshAutoNormalFooter footerWithRefreshingBlock:^{
        
        NSDictionary *dic = self.leftLabelAry[self.fristTableView.indexPathForSelectedRow.row];
        NSString *cellid = dic[@"id"];
        HYDUserModel *user = self.typeDic[cellid];
        [HYDServerAPI uploadRecommentUserData:cellid page:user.page success:^(id response) {
            user.page = response[@"next_page"];
            user.maxPage = response[@"total_page"];
            NSMutableArray *mutableAry = [NSMutableArray array];
            mutableAry = user.userAry;
            [mutableAry addObjectsFromArray:[HYDRecommendUser objectArrayWithKeyValuesArray:response[@"list"]]];
            user.userAry = mutableAry;
            [self.typeDic setValue:user forKey:cellid];
            
            self.rightLabelAry = user.userAry;
            
            if (self.distinguishStr != cellid) {
                return ;
            }
            
            [self.secondTableView reloadData];
            
            NSInteger nextpage = [response[@"next_page"] integerValue];
            NSInteger totalpage = [response[@"total_page"] integerValue];
            
            if ((nextpage-1) == totalpage) {
                [self.secondTableView.mj_footer endRefreshingWithNoMoreData];
//                self.secondTableView.mj_footer.hidden = YES;
            }else{
                [self.secondTableView.mj_footer endRefreshing];
            }
            
        } failuer:^(id error) {
            [self.secondTableView.mj_footer endRefreshing];
        }];
    }];
    self.secondTableView.mj_footer.hidden = YES;
    [self.view addSubview:self.secondTableView];
    
}

#pragma mark - 懒加载
-(NSMutableArray *)leftLabelAry{
    
    if (_leftLabelAry == nil) {
        _leftLabelAry = [NSMutableArray array];
    }
    return _leftLabelAry;
}
-(UITableView *)fristTableView{
    if (_fristTableView == nil) {
        _fristTableView = [[UITableView alloc]initWithFrame:CGRectMake(0, 64, ScreenWidth,ScreenHeight)];
    }
    return _fristTableView;
}
-(UITableView *)secondTableView{
    if (_secondTableView == nil) {
        _secondTableView = [[UITableView alloc]initWithFrame:CGRectMake(self.fristTableView.width, 64, ScreenWidth-64,ScreenHeight-64)];
    }
    return _secondTableView;
}



-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    if (tableView == self.fristTableView) {
           return self.leftLabelAry.count;
    }else{
        return self.rightLabelAry.count;
    }
 
}
-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    if (tableView == self.fristTableView) {
         NSString *cellID = @"cellID";
        HYDFristTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellID];
        if (cell == nil) {
            cell = [[HYDFristTableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellID];
        }
        NSDictionary *dic = self.leftLabelAry[indexPath.row];
        NSString *str = dic[@"name"];
        [cell creatData:str];
        
        return cell;
    }else{

         NSString *cellID = @"userCell";
        HYDSecondTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellID];
        cell = [[[NSBundle mainBundle] loadNibNamed:@"HYDSecondTableViewCell" owner:self options:nil] objectAtIndex:0];

        cell.userModel = self.rightLabelAry[indexPath.row];
        return cell;
    }
   
}


//返回手工计算的每一行cell的高度
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    if (tableView == self.fristTableView) {
        NSDictionary *dic = [[NSDictionary alloc]init];
        dic = self.leftLabelAry[indexPath.row];
        return [HYDSubscribeModel labelHeigh:[dic objectForKey:@"name"]];
    }else{
        return 70;
    }

}


-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    [self.secondTableView.mj_header endRefreshing];
    [self.secondTableView.mj_footer endRefreshing];
    
    if (tableView == self.fristTableView) {
        
        NSDictionary *dic = self.leftLabelAry[indexPath.row];
        NSString *cellid = dic[@"id"];
        HYDUserModel *user = self.typeDic[cellid];
        self.distinguishStr = cellid;
        if (user.userAry == 0) {
            self.secondTableView.mj_footer.hidden = YES;//隐藏底部刷新控件
            [HYDServerAPI getRecommentUserData:cellid success:^(id response) {
                NSArray *ary = [HYDRecommendUser objectArrayWithKeyValuesArray:response[@"list"]];
                NSMutableArray *mutableAry = [NSMutableArray array];
                [mutableAry addObjectsFromArray:ary];
                HYDUserModel *user = [[HYDUserModel alloc]init];
                user.userAry = mutableAry;
                user.page = response[@"next_page"];
                user.maxPage = response[@"total_page"];
                [self.typeDic setValue:user forKey:cellid];
                
                self.rightLabelAry = user.userAry;

                if (self.distinguishStr != cellid) {
                    return ;
                }
                [self.secondTableView reloadData];
                self.secondTableView.mj_footer.hidden = NO;
                NSInteger nextpage = [response[@"next_page"] integerValue];
                NSInteger totalpage = [response[@"total_page"] integerValue];
                
                if ((nextpage-1) == totalpage) {
                    [self.secondTableView.mj_footer endRefreshingWithNoMoreData];
                }else{
                    [self.secondTableView.mj_footer endRefreshing];
                }

            } failuer:^(id error) {
                
            }];
        }else{

            self.rightLabelAry = user.userAry;
            [self.secondTableView reloadData];
            
            NSInteger nextpage = [user.page integerValue];
            NSInteger totalpage = [user.maxPage integerValue];
            
            if ((nextpage-1) == totalpage) {
                [self.secondTableView.mj_footer endRefreshingWithNoMoreData];
            }
        }
        
    }else{
        [tableView deselectRowAtIndexPath:indexPath animated:YES];
    }
    
}


//解决cell的分割线向左移动15个像素
-(void)viewDidLayoutSubviews {
    
    if ([self.fristTableView respondsToSelector:@selector(setSeparatorInset:)]) {
        [self.fristTableView setSeparatorInset:UIEdgeInsetsZero];
        
    }
    if ([self.fristTableView respondsToSelector:@selector(setLayoutMargins:)])  {
        [self.fristTableView setLayoutMargins:UIEdgeInsetsZero];
    }
    
}

-(void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPat{
    if ([cell respondsToSelector:@selector(setLayoutMargins:)]) {
        [cell setLayoutMargins:UIEdgeInsetsZero];
    }
    if ([cell respondsToSelector:@selector(setSeparatorInset:)]){
        [cell setSeparatorInset:UIEdgeInsetsZero];
    }
}



@end
